include(CheckCCompilerFlag)

check_c_compiler_flag(-std=c11 HAS_CLANG_STYLE_STD_C11)
check_c_compiler_flag(--std=c11 HAS_GNUCC_STYLE_STD_C11)

check_c_compiler_flag(-std=c11 HAS_CLANG_STYLE_STD_C99)
check_c_compiler_flag(--std=c11 HAS_GNUCC_STYLE_STD_C99)

if (HAS_CLANG_STYLE_STD_C11))
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c11")
elseif(HAS_GNUCC_STYLE_STD_C11)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --std=c11")
elseif (HAS_CLANG_STYLE_STD_C99))
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")
elseif(HAS_GNUCC_STYLE_STD_C99)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --std=c99")
else()
  message(WARNING 
    "Could not determine option to set language to C99.  Compile may fail!")
endif()
