#ifndef __TS_MACROS__H__
#define __TS_MACROS__H__

#define SYMCAT3(x,y,z) SYMCAT( SYMCAT(x,y), z )
#define SYMCAT(x,y) SYMCAT0(x,y)
#define SYMCAT0(x,y) x ## y

#define SYMSTR(x) SYMSTR0(x)
#define SYMSTR0(x) # x

#define NULLIFY(x)

#define DEFINITION_EAT_SEMI \
  typedef struct { char c; } SYMCAT(eat_semi_, __LINE__)

#define STATIC_ASSERT( x ) \
  typedef struct { char compiler_error_means_static_assertion_failed[ 2*((x) != 0) - 1 ]; } SYMCAT( MODULE_NAME, SYMCAT( assertion_on_line_, __LINE__ ) )

#define ASSERT_SIZE_OF(typ, nbytes) \
  typedef struct { char compiler_error_means_type_is_not_asserted_size[ 2*(sizeof(typ) == nbytes) - 1 ]; } SYMCAT( MODULE_NAME, SYMCAT( assert_size_of_on_line, __LINE__ ) )

#define ASSERT_SIZE_EQ(typ1, typ2) \
  typedef struct { char compiler_error_means_types_are_not_same_size[ 2*(sizeof(typ1) == sizeof(typ2)) - 1 ]; } SYMCAT( MODULE_NAME, SYMCAT( assert_size_eq_on_line, __LINE__ ) )

#define ASSERT_SIZE_LE(typ1, typ2) \
  typedef struct { char compiler_error_means_size_of_first_type_greater_than_second[ 2*(sizeof(typ1) <= sizeof(typ2)) - 1 ]; } SYMCAT( MODULE_NAME, SYMCAT( assert_size_eq_on_line, __LINE__ ) )

#define BIT_VALUE(n)  ( 1UL << ((n)-1) )

#define SMALL 1e-6

#if defined(__GNUC__)
#  define MAYBE_UNUSED    __attribute__((unused))
#  define DOES_NOT_RETURN __attribute__((noreturn))
#  define NEVER_INLINE __attribute__((noinline))
#  define UNUSED_PARAM(x) (void)(x)
#  define BARRIER() __asm__ volatile("": : :"memory")
#  define FENCE() do { BARRIER(); __sync_synchronize(); } while(0)
#  define UNLIKELY(x) (__builtin_expect((x), 0))
#else
#  define MAYBE_UNUSED
#  define DOES_NOT_RETURN
#  define NEVER_INLINE
#  define UNUSED_PARAM(x) (void)(x)
#  define BARRIER() SOFTWARE_BARRIER_NOT_DEFINED()
#  define FENCE() CPU_FENCE_NOT_DEFINED()
#  define UNLIKELY(x) (x)
#endif

#endif /* __TS_MACROS__H__ */

