#ifndef __TS_MALLOC_PROTECT__H__
#define __TS_MALLOC_PROTECT__H__

/* Include this file to detect calls to malloc/calloc/realloc/free 
 *
 * The compiler should report errors when these calls are encountered.
 *
 * The preferred way to handle memory is with the
 * ts_alloc/ts_realloc/ts_calloc/ts_free functions.  These functions
 * allow custom allocators to be used in different parts of the code.
 */

/* guaranteed to force a compiler failure with malloc/callc/realloc */
extern void stdlib_alloc_catch(void);
#define malloc stdlib_alloc_catch
#define calloc stdlib_alloc_catch
#define realloc stdlib_alloc_catch
#define free stdlib_alloc_catch

#endif /* __TS_MALLOC_PROTECT__H__ */

