#ifndef TS_PARAMETERS_H
#define TS_PARAMETERS_H

#include "ts_errors.h"

#define MODULE_NAME TS_PARAMETERS

typedef struct ts_param_table ts_param_table;
struct ts_param_table;

ts_param_table* ts_param_table_new();
void ts_param_table_delete(ts_param_table* tbl);

TSResult ts_param_table_set(ts_param_table* tbl, const char* key, double val);
TSResult ts_param_table_get(ts_param_table* tbl, const char* key, double *valp);
int ts_param_table_exists(ts_param_table* tbl, const char* key);

typedef TSResult (*ts_parameter_func)(void* data, const char* key, double val);
TSResult ts_param_table_foreach(ts_param_table* tbl, ts_parameter_func func, void* data);

struct ts_param_iter { int64_t state; const char* key; double val; };
void ts_param_iter_init(ts_param_table* tbl, struct ts_param_iter* iter);
int ts_param_iter_next(ts_param_table* tbl, struct ts_param_iter* iter);

#undef MODULE_NAME

#endif /* TS_PARAMETERS_H */

