#include "ts_particle.h"

STATIC_ASSERT( BONDTYPE_RESERVED_OFFSET > 0 );
STATIC_ASSERT( BONDTYPE_VALUE_MASK > BONDTYPE_RESERVED_OFFSET );

STATIC_ASSERT( (BONDTYPE_FLAG_MASK & BONDTYPE_VALUE_MASK) == 0 );

STATIC_ASSERT( (BONDTYPE_FLAG_MASK & BONDTYPE_VALUE_MASK) == 0 );
STATIC_ASSERT( (BONDTYPE_FORW_BIT & BONDTYPE_BACK_BIT) == 0 );

STATIC_ASSERT( (BONDTYPE_BACK_BIT & BONDTYPE_FLAG_MASK) == (BONDTYPE_BACK_BIT) );
STATIC_ASSERT( (BONDTYPE_FORW_BIT & BONDTYPE_FLAG_MASK) == (BONDTYPE_FORW_BIT) );
STATIC_ASSERT( (BONDTYPE_BIDIREC_BIT & BONDTYPE_FLAG_MASK) == (BONDTYPE_BIDIREC_BIT) );

STATIC_ASSERT( BONDTYPE_DIREC_FLAGS(BONDTYPE_UNDIRECTED) == BONDTYPE_UNDIRECTED_BIT );
STATIC_ASSERT( BONDTYPE_DIREC_FLAGS(BONDTYPE_FORWARD   ) == BONDTYPE_FORW_BIT );
STATIC_ASSERT( BONDTYPE_DIREC_FLAGS(BONDTYPE_BACKWARD  ) == BONDTYPE_BACK_BIT );
STATIC_ASSERT( BONDTYPE_DIREC_FLAGS(BONDTYPE_BIDIRECTIONAL ) == BONDTYPE_BIDIREC_BIT );

STATIC_ASSERT( BT_REVERSE(BONDTYPE_FORW_BIT | 0x0021) == (BONDTYPE_BACK_BIT | 0x0021) );
STATIC_ASSERT( BT_REVERSE(BONDTYPE_FORW_BIT | 0x1021) == (BONDTYPE_BACK_BIT | 0x1021) );
STATIC_ASSERT( BT_REVERSE(BONDTYPE_FORW_BIT | 0x3021) == (BONDTYPE_BACK_BIT | 0x3021) );
STATIC_ASSERT( BT_REVERSE(BONDTYPE_BACK_BIT | 0x0A01) == (BONDTYPE_FORW_BIT | 0x0A01) );
STATIC_ASSERT( BT_REVERSE(BONDTYPE_UNDIRECTED_BIT | 0x0001) == (BONDTYPE_UNDIRECTED_BIT | 0x0001) );
STATIC_ASSERT( BT_REVERSE(BONDTYPE_BIDIREC_BIT | 0x0001) == (BONDTYPE_BIDIREC_BIT | 0x0001) );

/* Unused dummy symbol to avoid ranlib/ar warning */
extern const char* ts_particle_tests_symbol;
const char* ts_particle_tests_symbol = "ts_particle_tests";
