#include "ts_stats.h"

#include <stdlib.h>

void ts_accumulate_stats(struct ts_accumulated_stats*restrict stats, double newValue)
{
  double davg = (newValue - stats->mean)/(stats->count + 1);
  stats->mean += davg;
  stats->var = (1.0 - 1.0/(stats->count)) * stats->var + (stats->count+1)*davg*davg;
  stats->count++;

  if (newValue < stats->min) stats->min = newValue;
  if (newValue > stats->max) stats->max = newValue;
}

void ts_accumulated_stats_init(struct ts_accumulated_stats*restrict stats, double value)
{
  stats->mean = value;
  stats->var = 0.0;
  stats->count = 1;
  stats->min = value;
  stats->max = value;
}

