#ifndef TS_UNITS__H
#define TS_UNITS__H

#include <math.h>

#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif /* defined(M_PI) */

#define GAS_CONSTANT 0.008314462

#define UNIT_LENGTH_NANOMETERS 4.0
#define UNIT_LENGTH_METERS 4.0e-9

#define UNIT_MASS_KILODALTONS  50.0
#define UNIT_MASS_AMU          5.0e4

#define UNIT_TEMPERATURE_KELVIN  310.15


#define UNIT_ENERGY_KJMOL 2.5787303893
#define UNIT_ENERGY_JMOL 2578.7303893
#define UNIT_ENERGY_KCALMOL 0.61632

#define UNIT_TIME_NANOSECS 0.55698
#define UNIT_TIME_SECS     5.5698e-10

#define UNIT_VEL_NM_PER_NS 7.1816
#define UNIT_VEL_METERS_PER_SEC 7.1816

#define UNIT_DIFFUSION_SQNM_PER_NS 28.7263

#define HARMONIC_FREE_ENERGY_COEFF 4.4216161e-5

#define MODULE_NAME TS_UNITS
#undef MODULE_NAME

#endif /* TS_UNITS__H */

