#ifndef TS_VECLIST__H
#define TS_VECLIST__H

#include <stdlib.h>

#define MODULE_NAME TS_VECLIST

typedef struct VectorList VectorList;
struct VectorList
{
  size_t n;

  double* vX;
  double* vY;
  double* vZ;
};

VectorList* veclist_alloc(size_t n);
void veclist_dealloc(VectorList* vl);

int veclist_init(VectorList* vecList, size_t n);

void veclist_zero(VectorList* vecList);

int veclist_set(VectorList*restrict a, const VectorList*restrict b);

void veclist_add(VectorList*restrict a, const VectorList*restrict b);
void veclist_sub(VectorList*restrict a, const VectorList*restrict b);

void veclist_add3(VectorList*restrict dst, const VectorList*restrict a, const VectorList*restrict b);
void veclist_sub3(VectorList*restrict dst, const VectorList*restrict a, const VectorList*restrict b);

void veclist_scaleby(VectorList*restrict vecList, double scl);
void veclist_normalize(VectorList* vecList);

void veclist_sqdist_to(VectorList*restrict v0, const VectorList*restrict v1);
void veclist_distance_to(VectorList*restrict v0, const VectorList* v1);

void veclist_dot_with(VectorList*restrict v0, const VectorList*restrict v1);

#undef MODULE_NAME

#endif /* TS_VECLIST__H */

