#ifndef TSCH_CONFIG_PRIV_H
#define TSCH_CONFIG_PRIV_H

#include <stdbool.h>

#ifndef TSCH_CONFIG_H
#  error tsch_config_priv.h must be included after tsch_config.h
#endif /* TSCH_CONFIG_H */

#ifndef TSCH_CONFIG_PARSE_H
#  error tsch_config_priv.h must be included after tsch_config_parse.h
#endif /* TSCH_CONFIG_PARSE_H */

#define TOK_ERR 'e'

struct tsch_config;

struct tsch_cfg_id {
  struct tsch_string sym;
  bool exported;
};

static inline struct tsch_cfg_id
tsch_config_make_id(struct tsch_config_parser *p, const char *s)
{
  struct tsch_cfg_id id;
  id.sym = tsch_string_table_add(&p->strings, s,NULL);
  id.exported = false;
  return id;
}

struct tsch_cfg_id_path {
  struct tsch_config *parent;
  struct tsch_cfg_id id;
};

struct tsch_config_token {
  struct { int line0, line1, off0, off1; } loc;

  union {
    struct tsch_cfg_id id;
    struct tsch_cfg_id_path sxn;

    const char *str;
    double num;
    bool b;
    struct tsch_config *entry;
  };
};

typedef struct tsch_config_token YYSTYPE;
#define YYSTYPE_IS_DECLARED 1

#if !defined(TOK_ID)
enum {
  TOK_ID=257,
  TOK_NUM,
  TOK_STR,
  KW_TRUE,
  KW_FALSE,
  TOK_MIN,
  TOK_MAX,
  KW_SHARED,
  TOK_LE,
  TOK_GE,
  TOK_EQ,
  TOK_NE,
  TOK_AND,
  TOK_OR,
};
#endif /* !defined(TOK_ID) */

#endif /* TSCH_CONFIG_PRIV_H */

