#include "mruby.h"
#include "mruby/irep.h"

#include <stdlib.h>

#define CAT2(x,y) CAT2_(x,y)
#define CAT3(x,y,z)  x ## y ## z
#define GEM_INIT(n)  CAT3(mrb_, n, _gem_init)
#define GEM_FINAL(n) CAT3(mrb_, n, _gem_final)
#define GEM_IREP(n)  CAT3(mrb_, n, _irep)

#define XBOTH(n) \
  XCGEM(n) \
  XIREP(n)

#define XCGEM(n) \
  extern void GEM_INIT(n)  (mrb_state *mrb); \
  extern void GEM_FINAL(n) (mrb_state *mrb);
#define XIREP(n) \
  extern const uint8_t GEM_IREP(n) [];
#define XPROVIDE(n)
#include "mrbgems_registration_list.h"
#undef XCGEM
#undef XIREP
#undef XPROVIDE

static void init_irep(mrb_state* mrb, const uint8_t irep[])
{
  int ai = mrb_gc_arena_save(mrb);
  mrb_load_irep(mrb, irep);
  if (mrb->exc) {
    mrb_p(mrb, mrb_obj_value(mrb->exc));
    exit(0);
  }
  mrb_gc_arena_restore(mrb, ai);
}

extern void mrb_c_provide(mrb_state *mrb, const char* filename);

void mrb_init_mrbgems(mrb_state *mrb)
{
#define XCGEM(n) GEM_INIT(n) (mrb);
#define XIREP(n) init_irep(mrb, GEM_IREP(n));
#define XPROVIDE(n) mrb_c_provide(mrb, n);
#include "mrbgems_registration_list.h"
#undef XCGEM
#undef XIREP
#undef XPROVIDE
}

void mrb_final_mrbgems(mrb_state *mrb)
{
#define XCGEM(n) GEM_FINAL(n) (mrb);
#define XIREP(n)
#define XPROVIDE(n)
#include "mrbgems_registration_list.h"
#undef XCGEM
#undef XIREP
#undef XPROVIDE
}

