#ifndef TSMRB_CHEM_DRIVER_H
#define TSMRB_CHEM_DRIVER_H

#include "ts_chem_driver.h"
#include "mruby.h"

#include "tsmrb_classes.h"

ts_chem_driver *tsmrb_to_chem_driver(mrb_state* mrb, mrb_value obj);
struct tsch_sheet_length_bias *tsmrb_to_sheet_length_bias(mrb_state* mrb, mrb_value obj);
struct tsch_fast_sheet_model *tsmrb_to_fast_sheet_model(mrb_state* mrb, mrb_value obj);
struct tsch_config_parser *tsmrb_to_config_parser(mrb_state *mrb, mrb_value obj);

static inline struct RClass*
tsmrb_chem_driver_class(mrb_state* mrb)
{
  return tsmrb_classes(mrb)->cChemDriver;
}

static inline struct RClass*
tsmrb_sheet_length_bias_class(mrb_state* mrb)
{
  return tsmrb_classes(mrb)->cSheetLengthBias;
}

static inline struct RClass*
tsmrb_fast_sheet_model_class(mrb_state* mrb)
{
  return tsmrb_classes(mrb)->cFastSheetModel;
}

static inline struct RClass*
tsmrb_chem_configure_class(mrb_state* mrb)
{
  return tsmrb_classes(mrb)->cChemConfigure;
}

struct RClass*
tsmrb_define_chem_driver(mrb_state* mrb, struct RClass* mod);

#endif /* TSMRB_CHEM_DRIVER_H */

