#include "tsmrb_convenience.h"

#include "tsmrb_helpers.h"
#include "tsmrb_vec.h"
#include "tsmrb_mat3x3.h"

static mrb_value convenience_vec(mrb_state* mrb, mrb_value self)
{
  int argc = 0;
  mrb_value* argv = NULL;
  mrb_get_args(mrb, "*", &argv, &argc);

  return mrb_funcall_argv(mrb, 
      mrb_obj_value( tsmrb_vec3_class(mrb) ),
      TSMRB_SYM(new), argc, argv);
}

static mrb_value convenience_mat(mrb_state* mrb, mrb_value self)
{
  int argc = 0;
  mrb_value* argv = NULL;
  mrb_get_args(mrb, "*", &argv, &argc);

  return mrb_funcall_argv(mrb, 
      mrb_obj_value( tsmrb_mat3x3_class(mrb) ),
      TSMRB_SYM(new), argc, argv);
}

struct RClass* tsmrb_define_convenience(mrb_state* mrb, struct RClass* mod)
{
  if (tsmrb_convenience_module(mrb) != NULL)
    mrb_raise(mrb, E_RUNTIME_ERROR,
        "Convenience module has already been initialized!");

  struct RClass* mConvenience = mrb_define_module_under(mrb, mod, "Convenience");
  tsmrb_classes(mrb)->mConvenience = mConvenience;

  mrb_define_module_function(mrb, mConvenience, "vec", convenience_vec, MRB_ARGS_ANY());
  mrb_define_module_function(mrb, mConvenience, "mat", convenience_mat, MRB_ARGS_ANY());

  return mConvenience;
}


