#ifndef TSMRB_NUMERICAL_H
#define TSMRB_NUMERICAL_H

#include "mruby.h"
#include "tsmrb_helpers.h"
#include "tsmrb_classes.h"

#include "ts_sparse.h"

#define MODULE_NAME TSRB_NUMERICAL

static inline struct RClass*
tsmrb_sparse_builder_class(mrb_state* mrb)
{
  return tsmrb_classes(mrb)->cSparseBuilder;
}

static inline struct RClass*
tsmrb_sparse_class(mrb_state* mrb)
{
  return tsmrb_classes(mrb)->cSparseMatrix;
}

static inline struct RClass*
tsmrb_poly_class(mrb_state* mrb)
{
  return tsmrb_classes(mrb)->cPoly;
}

struct RClass* tsmrb_define_numerical(mrb_state* mrb, struct RClass* mod);

ts_sparse_t* tsmrb_to_sparse(mrb_state* mrb, mrb_value obj);
ts_sparse_builder_t* tsmrb_to_sparse_builder(mrb_state* mrb, mrb_value obj);

mrb_value tsmrb_new_sparse_builder(mrb_state* mrb, ts_sparse_builder_t** builderp);
mrb_value tsmrb_new_sparse(mrb_state* mrb, ts_sparse_t** matrixp);

#undef MODULE_NAME

#endif /* TSMRB_NUMERICAL_H */

