#ifndef TSMRB_POTENTIALS_H
#define TSMRB_POTENTIALS_H

#include "mruby.h"
#include "tsmrb_classes.h"

#include "ts_potentials.h"

struct RClass* tsmrb_define_potentials(mrb_state* mrb, struct RClass* mod);

Potential* tsmrb_to_potential(mrb_state* mrb, mrb_value obj);
mrb_value tsmrb_from_potential(mrb_state* mrb, Potential* pot);

WCAPotential* tsmrb_to_wca(mrb_state* mrb, mrb_value obj);

static inline struct RClass*
tsmrb_potentials_module(mrb_state* mrb)
{ return tsmrb_classes(mrb)->mPotentials; }

static inline struct RClass*
tsmrb_potential_class(mrb_state* mrb)
{ return tsmrb_classes(mrb)->cPotential; }

static inline struct RClass*
tsmrb_twobody_class(mrb_state* mrb)
{ return tsmrb_classes(mrb)->cTwoBody; }

static inline struct RClass*
tsmrb_threebody_class(mrb_state* mrb)
{ return tsmrb_classes(mrb)->cThreeBody; }

static inline struct RClass*
tsmrb_fourbody_class(mrb_state* mrb)
{ return tsmrb_classes(mrb)->cFourBody; }

static inline struct RClass*
tsmrb_harmonic_class(mrb_state* mrb)
{ return tsmrb_classes(mrb)->cHarmonic; }

static inline struct RClass*
tsmrb_angleharmonic_class(mrb_state* mrb)
{ return tsmrb_classes(mrb)->cAngleHarmonic; }

static inline struct RClass*
tsmrb_dihedral_class(mrb_state* mrb)
{ return tsmrb_classes(mrb)->cDihedral; }

static inline struct RClass*
tsmrb_wca_class(mrb_state* mrb)
{ return tsmrb_classes(mrb)->cWCA; }

#endif /* TSMRB_POTENTIALS_H */

