#ifndef TSMRB_SIM_H
#define TSMRB_SIM_H

#include "tubesheet.h"

#include "mruby.h"
#include "tsmrb_classes.h"

#define MODULE_NAME TSRB_C_SIM

ts_sim *tsmrb_to_sim(mrb_state *mrb, mrb_value obj);
mrb_value tsmrb_from_sim(mrb_state *mrb, ts_sim *sim);
mrb_value tsmrb_make_sim(mrb_state *mrb, ts_sim *sim);

ts_particle *tsmrb_to_particle(mrb_state *mrb, mrb_value obj);
size_t tsmrb_to_particle_index(mrb_state *mrb, mrb_value obj, ts_sim **simptr);
mrb_value tsmrb_from_particle(mrb_state *mrb, ts_sim *sim, size_t pind);

mrb_value tsmrb_sim_ptype_to_hash(mrb_state *mrb, ts_particle_type *ptype);

ts_rigid_body *tsmrb_to_rigid_body(mrb_state *mrb, mrb_value obj);
size_t tsmrb_to_rigid_body_index(mrb_state *mrb, mrb_value obj, ts_sim **simptr);
mrb_value tsmrb_from_rigid_body(mrb_state *mrb, ts_sim *sim, size_t bd_ind);

mrb_value tsmrb_rigid_body_type_info(mrb_state* mrb, struct ts_rigid_body_type *bd_type, int derived);

struct RClass *tsmrb_define_sim(mrb_state *mrb, struct RClass *mod);
struct RClass *tsmrb_define_particle(mrb_state *mrb, struct RClass *mod, struct RClass *cSim);
struct RClass *tsmrb_define_rigid_body(mrb_state *mrb, struct RClass *mod, struct RClass *cSim);

static inline struct RClass *
tsmrb_sim_class(mrb_state *mrb)
{
  return tsmrb_classes(mrb)->cSim;
}

static inline struct RClass *
tsmrb_particle_class(mrb_state *mrb)
{
  return tsmrb_classes(mrb)->cParticle;
}

static inline struct RClass *
tsmrb_rigid_body_class(mrb_state *mrb)
{
  return tsmrb_classes(mrb)->cRigidBody;
}

#undef MODULE_NAME

#endif /* __TSMRB_SIM__H__ */

