#ifndef TSMRB_VEC_H
#define TSMRB_VEC_H

#include "vector3.h"
#include "mruby.h"
#include "tsmrb_classes.h"

#define MODULE_NAME TSRB_CVECTOR

static inline struct RClass*
tsmrb_vec3_class(mrb_state* mrb)
{
  return tsmrb_classes(mrb)->cVec3;
}

struct RClass* tsmrb_define_vec3(mrb_state* mrb, struct RClass* mod);

vector3* tsmrb_to_vec3(mrb_state* mrb, mrb_value obj);
mrb_value tsmrb_from_vec3(mrb_state* mrb, const vector3*restrict v);
mrb_value tsmrb_new_vec3(mrb_state* mrb, vector3** vp);

mrb_value tsmrb_vec3_to_ary(mrb_state* mrb, vector3* v);

void obj_to_vec(mrb_state* mrb, mrb_value rvec, vector3* vec);

#undef MODULE_NAME

#endif /* TSMRB_VEC_H */


