#ifndef TSMRB_VECLIST_H
#define TSMRB_VECLIST_H

#include "vector3.h"
#include "ts_veclist.h"

#include "mruby.h"
#include "tsmrb_classes.h"

#define MODULE_NAME TSMRB_VECLIST

static inline struct RClass*
tsmrb_veclist_class(mrb_state* mrb)
{
  return tsmrb_classes(mrb)->cVectorList;
}

struct RClass* tsmrb_define_veclist(mrb_state* mrb, struct RClass* mod);

VectorList* tsmrb_to_veclist(mrb_state* mrb, mrb_value obj);
mrb_value tsmrb_new_veclist(mrb_state* mrb, size_t n, VectorList** vlptr);

/* Returns an uninitialized vector list that must be initialized
 * before use
 */
mrb_value tsmrb_alloc_veclist(mrb_state *mrb, VectorList** vlptr);

#undef MODULE_NAME

#endif /* TSMRB_VECLIST_H */

